module sevro(clk,sevro_ctrl,data_valid,RCServo_pulse);
input clk;
input [1:0] sevro_ctrl;
input data_valid;
output RCServo_pulse;

///////////////////////////////////////////////////////////////////////////
parameter ClkDiv = 195; 
reg [7:0] ClkCount;
reg ClkTick;

always @(posedge clk) ClkTick <= (ClkCount==ClkDiv-2);

always @(posedge clk) if(ClkTick) ClkCount <= 0; else ClkCount <= ClkCount + 1;
////////////////////////////////////////////////////////////////////////////
reg [11:0] PulseCount;

always @(posedge clk) if(ClkTick) PulseCount <= PulseCount + 1;

always@( posedge clk )
if(data_valid)
begin
	if(sevro_ctrl == 2'b10)
		pulse <= pulse-7;
	else
	if(sevro_ctrl == 2'b01)
		pulse <= pulse+7;
end

// make sure the RCServo_position is stable while the pulse is generated
reg RCServo_pulse;
reg[9:0] pulse;
//initial pulse = 380;
/*always @(posedge clk)
begin
if(right_posedge)
	pulse <= pulse-6;
else if(left_posedge)
	pulse <= pulse+6;
end
 */
always @(posedge clk) 
	begin
		if(PulseCount==0) RCServo_pulse <= 1;
		if(PulseCount>pulse) RCServo_pulse <= 0; 
	end
endmodule 
